//--------------------------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//--------------------------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 DarkGray
#property indicator_color2 DarkOrange
#property indicator_color3 DarkOrange
#property indicator_color4 LimeGreen
#property indicator_color5 DarkOrange
#property indicator_color6 LimeGreen
#property indicator_color7 DarkOrange
#property indicator_width3 2
#property indicator_style2 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT

#import "fourier extrapolation.dll"
    void fourierExtrapolation(double& source[], double& past[], double& prediction[], int pastBars, int lastBar, int futureBars, int harmonicsNo, double harmonicsTolerance);
#import

//
//
//
//
//

extern int     StoPeriod   =   14;    
extern int     StoSlowing  =    3;
extern double  BandsWidth  =    1;
extern int     BandsPeriod =   50;
extern int     BandsMethod =  MODE_SMA;
extern int     LastBar     =    0;    // Last bar in the past data
extern int     PastBars    =  400;    // Number of past bars
extern int     FutBars     =  200;    // Number of bars to predict 
extern int     HarmNo      =    8;    // Number of frequencies; HarmNo=0 computes PastBars harmonics
extern double  FreqTOL     = 0.0001;  // Tolerance of frequency calculation - FreqTOL > 0.001 may not converge

double indicatorValues[];
double pastValues[];
double pastValuesBu[];
double pastValuesBd[];
double futureValues[];
double futureValuesBu[];
double futureValuesBd[];

double source[];
double result[];
double prediction[];

//--------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
   if(HarmNo==0 || HarmNo>PastBars) HarmNo=PastBars;
      SetIndexBuffer(0,indicatorValues);
      SetIndexBuffer(1,pastValues);      SetIndexLabel(1,"past");
      SetIndexBuffer(2,futureValues);    SetIndexLabel(2,"prediction");
      SetIndexBuffer(3,pastValuesBu);  
      SetIndexBuffer(4,pastValuesBd);  
      SetIndexBuffer(5,futureValuesBu);
      SetIndexBuffer(6,futureValuesBd);
   IndicatorShortName("Fourier extrapolation - of stochastic");
   return(0);
}
int deinit(){return(0);}

//--------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         int np = PastBars; if (np>Bars)    np = Bars;
         int nf = FutBars;  if (nf<LastBar) nf = LastBar;

         if (ArraySize(source)     !=np)   ArrayResize(source,np);
         if (ArraySize(result)     !=np)   ArrayResize(result,np);
         if (ArraySize(prediction) !=nf+1) ArrayResize(prediction,nf+1);
               SetIndexShift(1,  -LastBar-1);
               SetIndexShift(2,nf-LastBar-1);
               SetIndexShift(3,  -LastBar-1);
               SetIndexShift(4,  -LastBar-1);
               SetIndexShift(5,nf-LastBar-1);
               SetIndexShift(6,nf-LastBar-1);

      //
      //
      //
      //
      //

      for(int i=limit; i>=0; i--) indicatorValues[i]=iStochastic(NULL,0,StoPeriod,1,StoSlowing,MODE_SMA,0,MODE_MAIN,i);
         double deviation=iStdDevOnArray(indicatorValues,0,BandsPeriod,0,BandsMethod,LastBar);
         ArrayCopy(source,indicatorValues,0,LastBar,np);
               fourierExtrapolation(source,result,prediction,np,LastBar,nf-1,HarmNo,FreqTOL); 
         ArrayCopy(pastValues  ,result); 
         ArrayCopy(futureValues,prediction);
         for(i=np; i>=0; i--) 
         { 
            pastValuesBu[i]=pastValues[i]+BandsWidth*deviation;
            pastValuesBd[i]=pastValues[i]-BandsWidth*deviation;
         }            
         for(i=nf; i>=0; i--) 
         { 
            futureValuesBu[i]=futureValues[i]+BandsWidth*deviation;
            futureValuesBd[i]=futureValues[i]-BandsWidth*deviation;
         }            

      //
      //
      //
      //
      //
      
      SetIndexDrawBegin(1,Bars-np-LastBar);
      SetIndexDrawBegin(2,Bars-nf);
      SetIndexDrawBegin(3,Bars-np-LastBar);
      SetIndexDrawBegin(4,Bars-np-LastBar);
      SetIndexDrawBegin(5,Bars-nf);
      SetIndexDrawBegin(6,Bars-nf);

   return(0); 
}

